package com.ruoyi.project.hit.controller;

import com.ruoyi.framework.web.controller.BaseController;
import com.ruoyi.framework.web.domain.AjaxResult;
import com.ruoyi.project.hit.domain.PupuUser;
import com.ruoyi.project.hit.domain.vo.UserLoginVO;
import com.ruoyi.project.hit.service.PupuUserService;
import com.ruoyi.project.hit.util.JwtUtil;
import com.ruoyi.project.hit.util.webSocket.WsServerEndpoint;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.concurrent.TimeUnit;

@RestController
@RequestMapping("/hit/user")
public class PupuUserController extends BaseController {
    @Autowired
    private PupuUserService pupuUserService;

    @Autowired
    private RedisTemplate redisTemplate;

    @PostMapping("/login")
    public AjaxResult login(@RequestBody UserLoginVO userLoginVO){
        PupuUser loginer = pupuUserService.login(userLoginVO);
        if(loginer!=null){
            String token = JwtUtil.generateToken(userLoginVO.getUserName());
            System.out.println("token:"+token);
            redisTemplate.opsForValue().set(token,loginer,60, TimeUnit.MILLISECONDS);
            return AjaxResult.success(token);
        }else {
            return AjaxResult.error("账号或密码错误");
        }
    }
    @PostMapping("/register")
    public AjaxResult register(@Validated @RequestBody PupuUser pupuUser){
        return toAjax(pupuUserService.register(pupuUser));
    }

}
